define([], function(AssessmentUI) {
    var AssessmentExported = {
        formatScore: function(score) {
            return formatTwoDecimal(score);
        },
        addQuestionsToSummary: function(questions, count) {
            var r = "";
            var q, s;
            for (var i = 0; i < questions.length; i++) {
                count++;
                q = questions[i];
                s = q.getScore();
                r += "<tr>" + "<td class='qstem'>" + q.description + "</td>" + "<td class='qscore'>" + formatScore((s.getScore() * 100)) + "%</td>" + "</tr>\n";
            }
            return r;
        },
        showReport: function(type, args, me) {
            var assessment = AssessmentEngine.assessment;
            var s = "<div id=\"overallscore\">Score: " + formatTwoDecimal((assessment.getScore()) * 100) + " %</div>" + "<div id=\"passingscore\">Passing Score: " + formatTwoDecimal((assessment.passingScore * 100)) + " %</div>";
            if (!assessment.ignoreSections) {
                // iterate thru all sections in the assessment
                var sectionList = assessment.children;
                var count = 0;
                for (var j = 0; j < sectionList.length; j++) {
                    var section = sectionList[j];
                    if (sectionList.length > 1) {
                        s += "<div class=\"sectionlbl\">Section: " + section.getLabel() + "</div>";
                    }
                    s += "<table class=\"detailtable\">\n" + "<tr><th id='stemheading' scope='col'>Question</th><th id='scoreheading' scope='col'>Score</th></tr>\n" + AssessmentExported.addQuestionsToSummary(section.children, count) + "</table>";
                }
            } else {
                s += "<table class=\"detailtable\">\n" + "<tr><th id='stemheading' scope='col'>Question</th><th id='scoreheading' scope='col'>Score</th></tr>\n" + AssessmentExported.addQuestionsToSummary(assessment.children, count) + "</table>";
            }
            s += "</div>";
            jQuery("#content")
                .hide();
            jQuery("#footer")
                .hide();
            jQuery("#tmr")
                .hide();
            jQuery(".nav-container")
                .hide();
            var elm = jQuery("#scoresummary");
            if (elm.length == 0) {
                elm = jQuery("<div id=\"scoresummary\"></div>");
                elm.insertAfter("#content");
            }
            elm.show();
            // elm.html(s); not working in IE9?
            elm[0].innerHTML = s;
            // bump the window so the screen reader updates
            window.focus();
        }
    };
    AssessmentEngine.events.scoreComplete.subscribe(AssessmentExported.showReport);
    return AssessmentExported;
});

function formatTwoDecimal(num) {
	var ret = "";
	ret += Math.floor(num);
	ret += ".";
	ret += Math.floor((num * 100) % 100);

	return ret;
};
