define([], function() {
    return function(args) {
        var searchController = {
            currentPage: -1,
            subscribers: null,
            slidingMenu: null,
            searchString: null,
			activeObject: null,
			resultsCount: -1,
            init: function() {
                jQuery.extend(this, args);
            },
			setResultsCount: function(resltsCount) {
				this.resultsCount = resltsCount;
				this.currentPage = -1; // Since we have not selected the first page.
			},
			setCurrentPage: function(pageNumber) {
				this.currentPage = pageNumber;
			},
			previous: function() {
				this.goToPage(this.currentPage - 1);
			},
			next: function() {
				this.goToPage(this.currentPage + 1);
			},
			goToPage: function(pageNumber) {
				var pageCount = this.resultsCount;
				if (pageNumber > -1 && pageNumber < pageCount && pageNumber !== this.currentPage) {
					var obj = jQuery("#search-page-" + pageNumber);
					obj.click();
					this.currentPage = pageNumber;
				}
			},
            searchStart: function(searchString) {
                var vc = ViewerController;
                subscribers = vc.events.navigate.subscribers;
                this.slidingMenu.setInSearch(true, searchString);
                vc.events.navigate.subscribe(this.update, this, true);
                vc.events.load.subscribe(this.update, this, true);
                if (vc.current != null) {
                    this.update();
                }
            },
            searchEnd: function() {
                // Restore the events that were detached
                this.slidingMenu.setInSearch(false);
                //this.slidingMenu.createNavigationList(true);
				// The current object list in the tree controller is different from the search list. So, reset it, so that it can be updated.
				var navigateObj;
				
				if ( this.activeObject != null )  
				{
					// If a search object was selected, then stay on the same object, just replace the treeview matching the search selected object.
					this.slidingMenu.treeController.resetCurrentObjectList();
					navigateObj = this.activeObject;
				}
				else
				{ // If a search object was not selected.
					navigateObj = ViewerController.current;
				}
				
                this.slidingMenu.treeController.displayListForObject(navigateObj);
                this.slidingMenu.setActiveNavElement(null, navigateObj.id);
            },
            setActiveObject: function(obj) {
                this.activeObject = obj;
			},
            navigateRoot: function() {
                this.slidingMenu.treeController.navigateRoot();
			},
            update: function() {
                // For now we are not doing anything here. But, we could move code from Search.js to here.
            }
        };
        jQuery(searchController.init());
        return searchController;
    };
});

